<?php 
use Automattic\WooCommerce\Utilities\OrderUtil;
use Automattic\WooCommerce\Internal\DataStores\Orders\CustomOrdersTableController;

class WCAFW_OrderDetailsPage
{
	//rplc: AfterShip, woocommerce-aftership, wcafw, WCAFW
	function __construct()
	{
		add_action( 'add_meta_boxes', array( &$this, 'woocommerce_metaboxes' ) );
		//Now managed via ajax, see Order model: add_action( 'woocommerce_process_shop_order_meta', array( &$this, 'woocommerce_process_shop_ordermeta' ), 99, 2 ); //99: using 99 info are not embedded into emails
	}
	
	public function woocommerce_process_shop_ordermeta( $order_id, $post_obj ) 
	{
		global $wcafw_order_model;
		
		if(wcafw_get_value_if_set($_POST, 'wcafw_tracking_data', false))
		{
			 $wcafw_order_model->save_tracking_data($order_id, $_POST['wcafw_tracking_data']);
		}
			
	}
	public function woocommerce_metaboxes() 
	{
		$screen = wc_get_container()->get( CustomOrdersTableController::class )->custom_orders_table_usage_is_enabled()
		? wc_get_page_screen_id( 'shop-order' )
		: 'shop_order';
		
		add_meta_box( 'wcafw-woocommerce-aftership',  esc_html__('AfterShip', 'woocommerce-aftership'), array( &$this, 'render_metabox' ), $screen, 'side', 'high');
	}
	public function render_metabox($post = null)
	{
		global $wcafw_html_model;
		
		$wcafw_html_model->render_add_new_tracking_metabox($post);
	}
}
?>