<?php 
class WCAFW_OrdersListPage
{
	public function __construct()
	{
		//HPOS 
		add_action( 'woocommerce_shop_order_list_table_custom_column', array($this, 'add_tacking_info_to_column'),10, 2 ); 
		add_filter( 'woocommerce_shop_order_list_table_columns', array($this, 'add_tracking_column'), 15 ); 
		//
		add_action( 'manage_edit-shop_order_columns', array( &$this, 'add_tracking_column'), 20, 1 );							//Same for HPOS
		add_action( 'manage_shop_order_posts_custom_column', array( &$this, 'add_tacking_info_to_column'), 10,2);				//Same for HPOS
	}
	//Order list columns
	function add_tracking_column($columns){ 
	
		global $wcafw_html_model;
		
		$wcafw_html_model->load_add_new_tracking_metabox_assets();
		
		wp_enqueue_style('wcafw-featherlight', WCAFW_PLUGIN_PATH.'/css/vendor/featherlight/featherlight.min.css');
		wp_enqueue_style('wcafw-info-tracking-box', WCAFW_PLUGIN_PATH.'/css/admin-orders-list-page.css');
		wp_enqueue_script('wcafw-featherlight', WCAFW_PLUGIN_PATH.'/js/vendor/featherlight/featherlight.min.js', array('jquery'));
		wp_enqueue_script('wcafw-info-tracking-box', WCAFW_PLUGIN_PATH.'/js/admin-orders-list-page.js', array('jquery'));
		
		$columns["wcafw_tracking_data"] =  esc_html__('Tracking', 'woocommerce-aftership');
		
		return $columns;
		
	}
	//Order list columns
	function add_tacking_info_to_column($column, $order_id_or_obj)
	{ 
		global $wcafw_html_model;	
		$order_id = is_object($order_id_or_obj) ? $order_id_or_obj->get_id() : $order_id_or_obj;
		switch ( $column ) 
		{
			case "wcafw_tracking_data" : ?>
				<div id="wcafw_tracking_container_<?php echo $order_id?>"> 
					<?php $wcafw_html_model->render_order_list_tracking_container($order_id); ?>
				</div>						
				<div class="wcaf-actions-container" id="wcaf-actions-container-<?php echo $order_id?>">
					<button class="button wcfa-modify-order-trackings-button" id="wcfa-modify-order-trackings-button-<?php echo $order_id; ?>" data-order-id="<?php echo $order_id; ?>"><?php  esc_html_e('Add/Edit', 'woocommerce-aftership'); ?></button>
					<img class="wcfa-order-trackings-metabox-loader" id="wcfa-order-trackings-metabox-loader-<?php echo $order_id; ?>" src="<?php echo WCAFW_PLUGIN_PATH.'/img/loader.gif'; ?>" width="24"></img>
				</div>
				<?php 				
			break; 
			
			
		}
			
	}
}
?>