<?php 
class WCAFW_SettingsPage
{
	public function __construct()
	{
		
	}
	
	//rplc: AfterShip, woocommerce-aftership, wcafw, WCAFW
	public function render_page()
	{
		global $wcafw_option_model;
		
		//Assets
		wp_enqueue_style( 'wcafw-admin-common', WCAFW_PLUGIN_PATH.'/css/admin-common.css');
		wp_enqueue_style( 'wcafw-admin-settings-page', WCAFW_PLUGIN_PATH.'/css/admin-settings-page.css');
		
		//Save
		$api_key_is_not_valid = false;
		if(isset($_POST['wcafw_options']))
		{
			$aftership = new WCAFW_AfterShip(wcafw_get_value_if_set($_POST['wcafw_options'], 'api_key', ""));
			if(!$aftership->is_api_key_valid())
			{
				$api_key_is_not_valid = true;
				$_POST['wcafw_options']['api_key'] = "";
			}
			$wcafw_option_model->save_options($_POST['wcafw_options']);
		}
		
		//Load
		$options = $wcafw_option_model->get_options();
		
		?>
		<div class="wrap white-box">
			<!-- <form action="options.php" method="post" > -->
				<form action="" method="post" >
				<h2 class="wcafw_section_title wcafw_no_margin_top"><?php  esc_html_e('Options', 'woocommerce-aftership');?></h3>
					
					<h3><?php  esc_html_e('API Key', 'woocommerce-aftership');?></h3>
					<div class="wcafw_option_group" >
						<p class="wcafw_general_option_description"><?php  wcfaw_html_escape_allowing_special_tags(__('Generate a valid API Key following the <a href="https://developers.aftership.com/reference/overview" target="_blank">instruction</a>. Once done copy it in the following text area to be able to track order via AfterShip service.', 'woocommerce-aftership')); ?></p>
						<input type="text" size="100" name="wcafw_options[api_key]" placeholder="<?php  esc_html_e('Type the API Key here', 'woocommerce-aftership'); ?>" value="<?php echo wcafw_get_value_if_set($options, 'api_key', ""); ?>"></input>
						<?php if($api_key_is_not_valid): ?>
							<span class="wcafw_error_message"><?php  esc_html_e('Api Key is not valid!', 'woocommerce-aftership'); ?> </span>
						<?php endif; ?>
					</div>
						
					<h3><?php  esc_html_e('Notification', 'woocommerce-aftership');?></h3>
					<p><?php  wcfaw_html_escape_allowing_special_tags(__("<strong>Note:</strong> for free plan, AfterShip won't send any notification.", 'woocommerce-aftership'));?></p>
					<div class="wcafw_option_group">						
						<?php  $selected = wcafw_get_value_if_set($options, 'notification_email', false) ? " checked='checked' " : " "; ?>
						<div class="wcafw_checkbox_container">
							<input type="checkbox" name="wcafw_options[notification_email]" <?php echo $selected; ?> class="wcafw_option_checbox_field" value="true"><?php  esc_html_e('Send notification emails', 'woocommerce-aftership'); ?></input>
							<p class="wcafw_general_option_description"><?php  esc_html_e('Customer billing email will be used as recipient for AfterShip notification emails', 'woocommerce-aftership');?></p>
							
						</div>					
					</div>
					<div class="wcafw_option_group">
						<?php  $selected = wcafw_get_value_if_set($options, 'notification_sms', false) ? " checked='checked' " : " "; ?>
						<div class="wcafw_checkbox_container">
							<input type="checkbox" name="wcafw_options[notification_sms]" <?php echo $selected; ?> class="wcafw_option_checbox_field" value="true"><?php  esc_html_e('Send notification smses', 'woocommerce-aftership'); ?></input>
							<p class="wcafw_general_option_description"><?php  esc_html_e('Customer billing phone will be used as recipient for AfterShip notification smses', 'woocommerce-aftership');?></p>
						</div>					
					</div>
					
					<h3><?php  esc_html_e('Admin orders list page', 'woocommerce-aftership');?></h3>
					<p><?php  esc_html_e("Select which element have to be displayed in the admin orders list page", 'woocommerce-aftership');?></p>
					<div class="wcafw_inline_block">
						<label><?php  esc_html_e('Company name', 'woocommerce-aftership');?></label>
						<select name="wcafw_options[orders_list_page][company_name]">
							<option value ="yes" <?php selected( wcafw_get_value_if_set($options, array('orders_list_page', 'company_name'), 'yes'), 'yes' ); ?>><?php  esc_html_e('Yes', 'woocommerce-aftership');?></option>
							<option value ="no"<?php selected( wcafw_get_value_if_set($options, array('orders_list_page', 'company_name'), 'yes'), 'no' ); ?>><?php  esc_html_e('No', 'woocommerce-aftership');?></option>
						</select>
					</div>
					<div class="wcafw_inline_block">
						<label><?php  esc_html_e('Tracking code', 'woocommerce-aftership');?></label>
						<select name="wcafw_options[orders_list_page][tracking_code]">
							<option value ="yes" <?php selected( wcafw_get_value_if_set($options, array('orders_list_page', 'tracking_code'), 'yes'), 'yes' ); ?>><?php  esc_html_e('Yes', 'woocommerce-aftership');?></option>
							<option value ="no"<?php selected( wcafw_get_value_if_set($options, array('orders_list_page', 'tracking_code'), 'yes'), 'no' ); ?>><?php  esc_html_e('No', 'woocommerce-aftership');?></option>
						</select>
					</div>
					<div class="wcafw_inline_block">
						<label><?php  esc_html_e('Status', 'woocommerce-aftership');?></label>
						<select name="wcafw_options[orders_list_page][status]">
							<option value ="yes" <?php selected( wcafw_get_value_if_set($options, array('orders_list_page', 'status'), 'yes'), 'yes' ); ?>><?php  esc_html_e('Yes', 'woocommerce-aftership');?></option>
							<option value ="no"<?php selected( wcafw_get_value_if_set($options, array('orders_list_page', 'status'), 'yes'), 'no' ); ?>><?php  esc_html_e('No', 'woocommerce-aftership');?></option>
						</select>
					</div>
					
					<h3><?php  esc_html_e('Frontend orders details page', 'woocommerce-aftership');?></h3>
					<div class="wcafw_inline_block">
						<label><?php  esc_html_e('Timeline position', 'woocommerce-aftership');?></label>
						<select name="wcafw_options[frontend_order_details_page][timeline_position]">
							<option value ="woocommerce_order_details_after_order_table" <?php selected( wcafw_get_value_if_set($options, array('frontend_order_details_page', 'timeline_position'), 'woocommerce_order_details_after_order_table'), 'woocommerce_order_details_after_order_table' ); ?>><?php  esc_html_e('After order details tabe', 'woocommerce-aftership');?></option>
							<option value ="woocommerce_order_details_after_customer_details"<?php selected( wcafw_get_value_if_set($options, array('frontend_order_details_page', 'timeline_position'), 'woocommerce_order_details_after_order_table'), 'woocommerce_order_details_after_customer_details' ); ?>><?php  esc_html_e('After customr details', 'woocommerce-aftership');?></option>
						</select>
					</div>
					<div class="wcafw_inline_block">
						<label><?php  esc_html_e('Timeline events order', 'woocommerce-aftership');?></label>
						<select name="wcafw_options[frontend_order_details_page][timeline_events_order]">
							<option value ="oldest_to_recent" <?php selected( wcafw_get_value_if_set($options, array('frontend_order_details_page', 'timeline_events_order'), 'oldest_to_recent'), 'oldest_to_recent' ); ?>><?php  esc_html_e('Oldest to most recent', 'woocommerce-aftership');?></option>
							<option value ="recent_to_oldest"<?php selected( wcafw_get_value_if_set($options, array('frontend_order_details_page', 'timeline_events_order'), 'oldest_to_recent'), 'recent_to_oldest' ); ?>><?php  esc_html_e('Most recent to oldest', 'woocommerce-aftership');?></option>
						</select>
					</div>
					<div class="wcafw_inline_block">
						<label><?php  esc_html_e('Show timeline collapsed', 'woocommerce-aftership');?></label>
						<select name="wcafw_options[frontend_order_details_page][timeline_show_collapsed]">
							<option value ="no" <?php selected( wcafw_get_value_if_set($options, array('frontend_order_details_page', 'timeline_show_collapsed'), 'no'), 'no' ); ?>><?php  esc_html_e('False', 'woocommerce-aftership');?></option>
							<option value ="yes"<?php selected( wcafw_get_value_if_set($options, array('frontend_order_details_page', 'timeline_show_collapsed'), 'no'),  'yes'); ?>><?php  esc_html_e('True', 'woocommerce-aftership');?></option>
						</select>
					</div>
					
					<h3><?php  esc_html_e('Custom tracking URL', 'woocommerce-aftership');?></h3>
					<div class="wcafw_option_group">
						<p class="wcafw_general_option_description"><?php  wcfaw_html_escape_allowing_special_tags(__('By default the tracking URL used is the <strong>https://track.aftership.com/</strong> address. If you want to use a custom one (for example <strong>http://yourcompany.aftership.com</strong>), type it in the followin text area.', 'woocommerce-aftership')); ?></p>
						<input type="text" size="100" name="wcafw_options[custom_tracking_url]" placeholder="<?php  esc_html_e('Type your custom tracking URL here', 'woocommerce-aftership'); ?>" value="<?php echo wcafw_get_value_if_set($options, 'custom_tracking_url', ""); ?>"></input>
					</div>
					
					<h2 class="wcafw_section_title "><?php  esc_html_e('Couriers', 'woocommerce-aftership');?></h3>
					<p class="wcafw_company_option_description"><?php  esc_html_e('Select the couriers that you will use to track shipments', 'woocommerce-aftership'); ?></p>
					<?php 
					$aftership_companies_list = $wcafw_option_model->get_companies_list();
					foreach($aftership_companies_list as $aftership_company_data): 
						$selected = wcafw_get_value_if_set($options, array('selected_company', $aftership_company_data[0]), false) ? " checked='checked' " : " "; ?>
						<div class="wcafw_checkbox_container">
							<input type="checkbox" name="wcafw_options[selected_company][<?php echo $aftership_company_data[0]; ?>]" <?php echo $selected; ?> class="wcafw_option_checbox_field" value="<?php echo $aftership_company_data[0]; ?>"><?php echo $aftership_company_data[1]; ?></input>
						</div>
					<?php endforeach; ?>
					
				<p class="submit">
					<input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e('Save', 'woocommerce-aftership'); ?>" />
				</p>
			</form>			
		</div>
		<?php 
	}
}
?>