<?php 
class WCAFW_HTML
{
	//rplc: AfterShip, woocommerce-aftership, wcafw, WCAFW
	function __construct()
	{
		add_action('wp_ajax_wcafw_load_new_company_widget', array($this, 'ajax_load_new_company_widget'));
		add_action('wp_ajax_wcafw_load_existing_company_widgets', array($this, 'ajax_load_existing_company_widgets'));
		add_action('wp_ajax_wcafw_load_order_tracking_metabox', array($this, 'ajax_load_order_tracking_metabox'));
		add_action('wp_ajax_wcafw_load_order_list_tracking_container', array($this, 'ajax_load_order_list_tracking_container'));
	}
	public function ajax_load_new_company_widget()
	{
		$order_id = isset($_POST['order_id']) ? $_POST['order_id'] : null;
		$this->render_tracking_company_widget(null, $order_id);
		
		wp_die();
	}
	public function ajax_load_existing_company_widgets()
	{
		global $wcafw_order_model;
		
		$data = $wcafw_order_model->get_tracking_data($_POST['order_id']);
		$this->render_tracking_company_widget($data, $_POST['order_id']);
		
		wp_die();
	}
	public function ajax_load_order_tracking_metabox()
	{
		if(isset($_POST['order_id']))
			$this->render_add_new_tracking_metabox($_POST['order_id'], true);
		
		wp_die();
	}
	public function ajax_load_order_list_tracking_container()
	{
		if(isset($_POST['order_id']))
			$this->render_order_list_tracking_container($_POST['order_id']);
		
		wp_die();
	}
	public function load_add_new_tracking_metabox_assets($order_id = 'none')
	{
		wp_enqueue_style( 'wcafw-admin-tracking-metabox', WCAFW_PLUGIN_PATH.'/css/admin-tracking-metabox.css');	
		wp_register_script( 'wcfa-admin-tracking-metabox', WCAFW_PLUGIN_PATH.'/js/admin-tracking-metabox.js', array('jquery'));	
		wp_localize_script( 'wcfa-admin-tracking-metabox', 'wcafw', array(
																'order_id' => $order_id, //If "none", it has to be read from the container data-order-id attribute
																'notifications_sent_for_msg' =>  esc_html__('Notification sent for Tracking code(s): ','woocommerce-aftership')
																) );
		wp_enqueue_script( 'wcfa-admin-tracking-metabox' );
	}
	public function render_add_new_tracking_metabox($obj_or_id, $is_ajax = false)
	{
		global $wcafw_option_model, $wcafw_order_model;
		
		$number_of_trackings = 0;
		if(is_numeric($obj_or_id))
		{
			$order_id =  $obj_or_id;
			$order = wc_get_order($order_id);
		}
		else 
		{
			$order = ( $obj_or_id instanceof WP_Post ) ? wc_get_order( $obj_or_id->ID ) : $obj_or_id;
			$order_id = ( $obj_or_id instanceof WP_Post ) ? $obj_or_id->ID : $obj_or_id->get_id();
		}
		
		
		
		if(!$is_ajax)
		{
			$this->load_add_new_tracking_metabox_assets($order_id);
		}
		else 
		{
			$order = wc_get_order($order_id);
			$data = $wcafw_order_model->get_tracking_data( $order_id );
			$number_of_trackings = count($data);
		}
		//Existing data -> done via js to avoid to block the UI -> handler defined in WCAF_HTML
	
		?>
		<div id="wcafw_data_form"> 
			<?php if($is_ajax): ?>
				<h1><?php esc_html_e('Trackings for order:', 'woocommerce-aftership'); ?> #<?php echo $order->get_order_number( ); ?></h1> 
				<p><?php esc_html_e('Add, edit or remove tracking data. Once done click the "Save" button. To close the dialog click on the "X" button in the upper right corner.', 'woocommerce-aftership'); ?></p>
			<?php endif; ?>
			<div id="wcafw_new_companies_container" data-order-id="<?php echo $order_id; ?>" data-initial-number-of-trackings="<?php echo $number_of_trackings; ?>" data-is-ajax="<?php echo $is_ajax ? 'yes' : 'no'; ?>"></div>
			<div id="wcafw_loading"><?php esc_html_e('Please wait...', 'woocommerce-aftership'); ?></div>
			<div id="wcafw_status"></div>
			<?php if(!$wcafw_option_model->api_key_has_been_entered()): ?>
				<span class="wcafw_no_api_key_warning"><?php esc_html_e('No valid API Key has been entered thorugh the Options menu.', 'woocommerce-aftership'); ?></span>
			<?php else: ?>
				<button id="wcafw_add_new_company_button" class="button button-primary wcafw_button_to_disable" data-order-id="<?php echo $order_id; ?>"><?php esc_html_e('Add tracking', 'woocommerce-aftership'); ?></button>
				<button id="wcafw_save" class="button wcafw_button_to_disable"><?php esc_html_e('Save', 'woocommerce-aftership'); ?></button>
			<?php endif; ?>
		</div>
		<?php 
	}
	public function render_tracking_company_widget($data = null, $order_id = null, $errors = array())
	{
		global $wcafw_option_model,  $wcafw_order_model, $wcafw_product_model;
		
		
		$companies_list = $wcafw_option_model->get_selected_companies_list();
		$companies_complete_list = $wcafw_option_model->get_complete_companies_list();
		$unique_id = rand (12312, 9999999);
		$wc_order = $order_id ? wc_get_order($order_id) : false;
		?>
		<?php 
			if(!empty($errors)): ?>
				<div class="wcafw_error_container">
				<h3><?php  esc_html_e('Error', 'woocommerce-aftership'); ?></h3>
				<?php foreach($errors as $error): ?>
					<div class="wcfaw_error_line"><?php  printf(esc_html__('Tracking code: %s, Company code: %s', 'woocommerce-aftership'), $error['tracking_code'], $error['company_code']); ?> => <?php echo  $error['error']; ?> </div>
				<?php endforeach; ?>
				</div>
			<?php endif; 
			if(!isset($data)):?>
			<div class="wcafw_inside" id="wcafw_company_container_<?php echo $unique_id; ?>">
				<input type="hidden" id="wcafw_delete_field_<?php echo $unique_id; ?>" name="wcafw_tracking_data[<?php echo $unique_id; ?>][type]" value="creation"></input>
				<input type="hidden" id="wcafw_delete_field_<?php echo $unique_id; ?>" name="wcafw_tracking_data[<?php echo $unique_id; ?>][unique_id]" value="<?php echo $unique_id; ?>"></input>
				<!-- <label class="wcafw_label"><?php esc_html_e('ID', 'woocommerce-aftership'); ?></label>
				<span class="wcafw_unique_id"><?php echo $unique_id; ?></span> -->
				
				<label class="wcafw_label"><?php esc_html_e('Select company', 'woocommerce-aftership'); ?></label>
				<select name="wcafw_tracking_data[<?php echo $unique_id; ?>][company_code]">
					<?php foreach($companies_list as $company_id => $company_name): ?>
					<option value="<?php echo $company_id;?>"><?php echo $company_name;?></option>
					<?php endforeach; ?>
				</select>
				
				<label class="wcafw_label"><?php esc_html_e('Tracking code', 'woocommerce-aftership'); ?></label>
				<span id="wcafw_tracking_code_error_message_<?php echo $unique_id; ?>" class="wcafw_tracking_code_error_message"><?php esc_html_e('Cannot be empty', 'woocommerce-aftership'); ?></span>
				<input type="text" class="wcafw_tracking_code_input" name="wcafw_tracking_data[<?php echo $unique_id; ?>][tracking_code]"></input>
				
				<?php if($wc_order): ?>
				<label class="wcafw_label"><?php esc_html_e('Associated product', 'woocommerce-aftership'); ?></label>
				<p class="wcafw_small_description"><?php esc_html_e('Use this option only if you wish to give feedback to the user about which products the shipment refers', 'woocommerce-aftership'); ?></p>
				<select name="wcafw_tracking_data[<?php echo $unique_id; ?>][associated_product][]" class="wcafw_associated_product_select" multiple>
				<?php 
					foreach($wc_order->get_items() as $order_item):
					$specific_product_id = $order_item->get_variation_id() ? $order_item->get_variation_id() : $order_item->get_product_id();
					$attributes = $wcafw_product_model->get_order_variation_attribute_value_and_name($order_item->get_product());
					?>
					<option value="<?php echo $order_item->get_id()?>"><?php echo $order_item->get_name()." ".$attributes;?></option>
					<?php 
					endforeach;
				?>
				</select>	
				<?php endif;?>
				
				<label class="wcafw_label"><?php esc_html_e('Note', 'woocommerce-aftership'); ?></label>
				<textarea name="wcafw_tracking_data[<?php echo $unique_id; ?>][note]"></textarea>
				<button data-id="<?php echo $unique_id; ?>" class=" button wcafw_delete_button" id="wcafw_delete_button" data-is-temp="true"><?php esc_html_e('Delete', 'woocommerce-aftership'); ?></button>
			</div>
			<?php
			//Renders existing companies data
			else:
				foreach((array)$data as $unique_id => $tracking_data):
				$status = $wcafw_order_model->get_tracking_status($tracking_data['company_code'], $tracking_data['tracking_code'], $order_id);
				$tracking_url = $wcafw_option_model->get_options('custom_tracking_url', "https://track.aftership.com/".$tracking_data['company_code']);
			?>
				<div class="wcafw_inside" id="wcafw_company_container_<?php echo $unique_id; ?>">
					<input type="hidden" id="wcafw_delete_field_<?php echo $unique_id; ?>" name="wcafw_tracking_data[<?php echo $unique_id; ?>][to_delete]" value="no"></input>
					<input type="hidden" id="wcafw_delete_field_<?php echo $unique_id; ?>" name="wcafw_tracking_data[<?php echo $unique_id; ?>][type]" value="update"></input>					
					<input type="hidden" id="wcafw_delete_field_<?php echo $unique_id; ?>" name="wcafw_tracking_data[<?php echo $unique_id; ?>][unique_id]" value="<?php echo $unique_id; ?>"></input>
					
					<!-- <label class="wcafw_label"><?php esc_html_e('ID', 'woocommerce-aftership'); ?></label>
					<span class="wcafw_unique_id"><?php echo $unique_id; ?></span> -->
					
					<label class="wcafw_label"><?php echo wcafw_get_value_if_set($companies_complete_list, $tracking_data['company_code'], $tracking_data['company_code']); ?></label>
					<img class="wcafw_courier_logo" width="64" src="https://assets.aftership.com/couriers/svg/<?php echo $tracking_data['company_code']; ?>.svg"></img>
					<!-- <input type="text" name="wcafw_tracking_data[<?php echo $unique_id; ?>][company_code]" value="<?php echo wcafw_get_value_if_set($companies_complete_list, $tracking_data['company_code'], $tracking_data['company_code']); ?>" disabled="disabled"></input>
					-->
					
					<label class="wcafw_label"><?php esc_html_e('Tracking code', 'woocommerce-aftership'); ?></label>
					<!-- <input type="text" name="wcafw_tracking_data[<?php echo $unique_id; ?>][tracking_code]" value="<?php echo $tracking_data['tracking_code']; ?>" disabled="disabled"></input>-->
					<span class="wcafw_tracking_code"><a target="_blank" href="<?php echo $tracking_url ."/".$tracking_data['tracking_code']; ?>"><?php echo $tracking_data['tracking_code']; ?></a></span>
					
					<label class="wcafw_label"><?php esc_html_e('Status', 'woocommerce-aftership'); ?></label>
					<?php echo $status['status_icon']; ?>
					<span class="wcafw_status_message"><?php echo $status['status'];  ?></span>
					
					<label class="wcafw_label"><?php esc_html_e('Status message by courier', 'woocommerce-aftership'); ?></label>
					<span class="wcafw_status_message"><?php echo $status['message'];  ?></span>
					
					<?php if($wc_order): ?>
					<label class="wcafw_label"><?php esc_html_e('Associated product', 'woocommerce-aftership'); ?></label>
					<p class="wcafw_small_description"><?php esc_html_e('Use this option only if you wish to give feedback to the user about which products the shipment refers', 'woocommerce-aftership'); ?></p>
					<select name="wcafw_tracking_data[<?php echo $unique_id; ?>][associated_product][]" multiple class="wcafw_associated_product_select">
					<?php 
						$selected = wcafw_get_value_if_set($tracking_data, 'associated_product', array());
						foreach($wc_order->get_items() as $order_item):
						$specific_product_id = $order_item->get_variation_id() ? $order_item->get_variation_id() : $order_item->get_product_id();
						$attributes = $wcafw_product_model->get_order_variation_attribute_value_and_name($order_item->get_product());
						?>
						<option value="<?php echo $order_item->get_id() ?>" <?php selected(in_array($order_item->get_id(), $selected)) ?>><?php echo $order_item->get_name()." ".$attributes;?></option>
						<?php 
						endforeach;
					?>
					</select>	
					<?php endif;?>
					
					<label class="wcafw_label"><?php esc_html_e('Note', 'woocommerce-aftership'); ?></label>
					<textarea name="wcafw_tracking_data[<?php echo $unique_id; ?>][note]"><?php echo $tracking_data['note'] ?></textarea>
					
					<label class="wcafw_label"><?php esc_html_e('Active notification', 'woocommerce-aftership'); ?></label>
					<p class="wcafw_small_description"><?php wcfaw_html_escape_allowing_special_tags(__('Saving the order, will send an email notification containing the tracking info. Email template can be configured through the Email menu. In case of multiple tracking info, the plugin will send only one email containing all the data. Click the <strong>save</strong> button to send the notification.', 'woocommerce-aftership')); ?></p>
					<input type="checkbox" value="true" name="wcafw_tracking_data[<?php echo $unique_id; ?>][active_notification]"></input>
					
					<button data-id="<?php echo $unique_id; ?>" class="button wcafw_delete_button" id="wcafw_delete_button" data-is-temp="false"><?php esc_html_e('Delete', 'woocommerce-aftership'); ?></button>
				</div>
			<?php
				endforeach;
			endif;
		
	}
	public function render_order_list_tracking_container($order_id)
	{
		global $wcafw_option_model,  $wcafw_order_model;
		
		$data = $wcafw_order_model->get_tracking_data( $order_id );
		$companies_list = $wcafw_option_model->get_selected_companies_list();
		$companies_complete_list = $wcafw_option_model->get_complete_companies_list();
		$options = $wcafw_option_model->get_options();
		$counter = 0;
		foreach((array)$data as $unique_id => $tracking_data):
		$tracking_url = wcafw_get_value_if_set($options, 'custom_tracking_url', "https://track.aftership.com/".$tracking_data['company_code']);
		?>
			<div class="wcaf_tracking_data_container <?php echo ($counter++)%2==0 ? 'wcaf_tracking_data_container_even' : 'wcaf_tracking_data_container_odd'; ?>">
				
				<?php if(wcafw_get_value_if_set($options, array('orders_list_page', 'company_name'), 'yes') == 'yes'): ?>
					<!--<label class="wcafw_ol_label wcaf_company_code_label"><?php esc_html_e('Company', 'woocommerce-aftership'); ?></label>-->
					<div class="wcafw_company_data_container">
						<img class="wcafw_courier_logo_small" width="24" src="https://assets.aftership.com/couriers/svg/<?php echo $tracking_data['company_code']; ?>.svg"></img>
						<span class="wcaf_company_name_label"><?php echo wcafw_get_value_if_set($companies_complete_list, $tracking_data['company_code'], $tracking_data['company_code']); ?></span>
					</div>
				<?php endif; ?>
				
				<?php if(wcafw_get_value_if_set($options, array('orders_list_page', 'tracking_code'), 'yes') == 'yes'): ?>
					<!--<label class="wcafw_ol_label wcaf_tracking_code_label"><?php esc_html_e('Tracking code', 'woocommerce-aftership'); ?></label>-->
					<span class="wcafw_ol_tracking_code"><a target="_blank" href="<?php echo $tracking_url."/".$tracking_data['tracking_code']; ?>"><?php echo $tracking_data['tracking_code']; ?></a></span>
				<?php endif; ?>
				
				<?php if(wcafw_get_value_if_set($options, array('orders_list_page', 'status'), 'yes') == 'yes'): ?>
					<!--<label class="wcafw_ol_label wcaf_tracking_code_label"><?php esc_html_e('Status', 'woocommerce-aftership'); ?></label>-->
					<span class="wcafw_tracking_status wcafw_tracking_status_<?php echo $order_id;?>" data-order-id="<?php echo $order_id;?>" data-tracking="<?php echo $tracking_data['tracking_code'];?>" data-company="<?php echo $tracking_data['company_code'];?>"><img src="<?php echo WCAFW_PLUGIN_PATH.'/img/loader.gif'; ?>" width="24"></img></span>
				<?php endif; ?>
			</div>
		<?php	
			endforeach;?>		
		<?php 
	}
}
?>