"use strict";
let wcafw_tracking_queue = new Array();
let wcafw_tracking_queue_index = 0;
let wcafw_current_id = 0;
let wcafw_status_loading = true;
let wcafw_current_lightbox = 0;
jQuery(document).ready(function()
{
	jQuery(document).on('click', '.wcfa-modify-order-trackings-button', wcafw_load_tracking_metabox);
	wcafw_load_statuses('.wcafw_tracking_status');
});
function wcafw_load_statuses(status_class_name)
{
	jQuery(status_class_name).each(function(index, elem)
	{
		wcafw_tracking_queue.push(elem);
	});
	
	wcafw_status_loading = true;
	wcaf_load_next_status(wcafw_tracking_queue[wcafw_tracking_queue_index]);
}
function wcafw_add_new_stauses_to_load(status_class_name)
{
	if(wcafw_status_loading)
	{
		jQuery(status_class_name).each(function(index, elem)
			{
				if(!wcafw_tracking_queue.includes(elem))
					wcafw_tracking_queue.push(elem);
			});
	}
	else 
	{
		wcafw_load_statuses('.wcafw_tracking_status_'+wcafw_current_id);
	}
}
function wcaf_load_next_status(elem)
{
	const formData = new FormData();
	formData.append('action', 'wcafw_ajax_get_order_tracking_status');	
	formData.append('company_code', jQuery(elem).data('company'));	
	formData.append('tracking_code', jQuery(elem).data('tracking'))	
	formData.append('order_id', jQuery(elem).data('order-id'))	
				
	jQuery.ajax({
			url: ajaxurl,
			type: 'POST',
			data: formData, 
			async: true,
			success: function (data) 
			{
				jQuery(elem).html(data);
				//load next element
				setTimeout(function()
				{
					if(++wcafw_tracking_queue_index < wcafw_tracking_queue.length)
						wcaf_load_next_status(wcafw_tracking_queue[wcafw_tracking_queue_index]);
					else 
						wcafw_status_loading = false;
				}, 200);
			},
			error: function (data) 
			{
				
			},
			cache: false,
			contentType: false,
			processData: false
		}); 
}
function wcafw_load_tracking_metabox(event)
{
	event.preventDefault();
	
	const order_id = jQuery(event.currentTarget).data('order-id');
	wcafw_current_id = order_id;
	
	//UI
	jQuery(event.currentTarget).hide();
	jQuery("#wcfa-order-trackings-metabox-loader-"+order_id).show();
	
	const formData = new FormData();
	formData.append('action', 'wcafw_load_order_tracking_metabox');	
	formData.append('order_id', order_id)	
	
	jQuery.ajax({
			url: ajaxurl,
			type: 'POST',
			data: formData, 
			async: true,
			success: function (data) 
			{
				//UI
				jQuery(event.currentTarget).show();
				jQuery("#wcfa-order-trackings-metabox-loader-"+order_id).hide();				
				wcafw_current_lightbox = jQuery.featherlight(data, {beforeClose:wcafw_reload_tracking_container});
				
				wcafw_init_tracking_metabox();				
			},
			error: function (data) 
			{
				
			},
			cache: false,
			contentType: false,
			processData: false
		}); 
		
	return false;
}
function wcafw_reload_tracking_container(event)
{
	
	//UI
	jQuery("#wcfa-order-trackings-metabox-loader-"+wcafw_current_id).show();
	jQuery("#wcfa-modify-order-trackings-button-"+wcafw_current_id).hide();
	jQuery("#wcafw_tracking_container_"+wcafw_current_id).hide();
	//wcafw_current_lightbox.close();
	
	const formData = new FormData();
	formData.append('action', 'wcafw_load_order_list_tracking_container');	
	formData.append('order_id', wcafw_current_id)	
	
	jQuery.ajax({
			url: ajaxurl,
			type: 'POST',
			data: formData, 
			async: true,
			success: function (data) 
			{
				jQuery("#wcafw_tracking_container_"+wcafw_current_id).html(data);
				
				//UI
				jQuery(event.currentTarget).show();
				jQuery("#wcfa-order-trackings-metabox-loader-"+wcafw_current_id).hide();	
				jQuery("#wcfa-modify-order-trackings-button-"+wcafw_current_id).show();				
				jQuery("#wcafw_tracking_container_"+wcafw_current_id).show();		

				//Status loading managment
				wcafw_add_new_stauses_to_load('.wcafw_tracking_status_'+wcafw_current_id);
						
			},
			error: function (data) 
			{
				
			},
			cache: false,
			contentType: false,
			processData: false
		}); 
}