"use strict";
jQuery(document).ready(function()
{
	jQuery(document).on('click', '#wcafw_add_new_company_button', wcafw_add_new_company);
	jQuery(document).on('click', '.wcafw_delete_button', wcafw_delete_company);
	jQuery(document).on('click', '#wcafw_save', wcafw_save_data);
	jQuery(document).on('keypress', '.wcafw_tracking_code_input', wcafw_on_tracking_code_input_enter);
	
	wcafw_init_tracking_metabox();
});

function wcafw_init_select2()
{
	jQuery('.wcafw_associated_product_select').select2();
}
function wcafw_on_loading()
{
	jQuery('#wcafw_status').html("");
	jQuery('#wcafw_loading').fadeIn();
	jQuery('.wcafw_button_to_disable').prop('disabled', true);
}
function wcaf_on_save()
{
	wcafw_on_loading();
	jQuery('#wcafw_new_companies_container').append("<div class='wcafw_loading_layer' />");
}
function wcaf_on_save_competed(active_notification_sent_for)
{
	wcafw_completed_loading();
	jQuery('#wcafw_status').html(active_notification_sent_for != "" ? wcafw.notifications_sent_for_msg+active_notification_sent_for : "");
	jQuery('#wcafw_new_companies_container').fadeIn();
}
function wcafw_completed_loading()
{
	jQuery('#wcafw_loading').fadeOut();
	jQuery('.wcafw_button_to_disable').prop('disabled', false);
}
function wcafw_on_tracking_code_input_enter(event)
{
	var keycode = (event.keyCode ? event.keyCode : event.which);
    if(keycode == '13')
	{
	   event.preventDefault();
	   event.stopPropagation();
       jQuery('#wcafw_save').trigger('click');
	   return false;
    }
}
function wcafw_init_tracking_metabox()
{
	//UI
	wcafw_on_loading();
	
	const is_orders_list_page = jQuery("#wcafw_new_companies_container").data('is-ajax') == 'yes';
	const initial_number_of_trackings = jQuery("#wcafw_new_companies_container").data('initial-number-of-trackings');
	const formData = new FormData();
	formData.append('action', 'wcafw_load_existing_company_widgets');	
	formData.append('order_id', wcafw.order_id != 'none' ? wcafw.order_id : jQuery("#wcafw_new_companies_container").data('order-id'));	
	 		
	if(!is_orders_list_page || initial_number_of_trackings > 0)
		jQuery.ajax({
				url: ajaxurl,
				type: 'POST',
				data: formData, 
				async: true,
				success: function (data) 
				{
					//UI				
					wcafw_completed_loading();	
					jQuery('#wcafw_new_companies_container').html(data);
					wcafw_init_select2();
				},
				error: function (data) 
				{
					//console.log(data);
					//alert("Error: "+data);
				},
				cache: false,
				contentType: false,
				processData: false
			}); 
	else 
		wcafw_add_new_company(null);
	
	return false;
}
function wcafw_save_data(event)
{
	
	event.preventDefault();
	event.stopPropagation();
	
	//UI
	wcaf_on_save();
	
	const serialized_data = jQuery('#wcafw_data_form *').serialize();
	var updated_id = new Array();
	const formData = new FormData();
	formData.append('action', 'wcafw_save_data');	
	formData.append('order_id', wcafw.order_id != 'none' ? wcafw.order_id : jQuery("#wcafw_new_companies_container").data('order-id'));
	formData.append('serialized_data', serialized_data);	
	jQuery.ajax({
			url: ajaxurl,
			type: 'POST',
			data: formData,
			async: true,
			success: function (data) 
			{
				//UI
				var result = jQuery.parseJSON(data);
				jQuery('#wcafw_new_companies_container').html(result.html);
				wcaf_on_save_competed(result.active_notification_sent_for);
				wcafw_init_select2();
				document.dispatchEvent(new Event('wcafw_event_save_completed'));
			},
			error: function (data) 
			{
				document.dispatchEvent(new Event('wcafw_event_save_completed'));
				//console.log(data);
				//alert("Error: "+data);
			},
			cache: false,
			contentType: false,
			processData: false
		});  
	
	return false;
}
function wcafw_add_new_company(event) 
{
	if(event != null)
	{
		event.preventDefault();
		event.stopPropagation();
	}
		
	//UI
	wcafw_on_loading();
	
	const formData = new FormData();
	formData.append('action', 'wcafw_load_new_company_widget');	
	formData.append('order_id', event ? jQuery(event.currentTarget).data('order-id') : wcafw_current_id);	
	 			
	jQuery.ajax({
			url: ajaxurl,
			type: 'POST',
			data: formData,
			async: true,
			success: function (data) 
			{
				//UI
				jQuery('#wcafw_new_companies_container').append(data);
				wcafw_init_select2();
				wcafw_completed_loading();
			},
			error: function (data) 
			{
				//console.log(data);
				//alert("Error: "+data);
			},
			cache: false,
			contentType: false,
			processData: false
		}); 
	
	return false;
}
function wcafw_delete_company(event)
{
	event.preventDefault();
	event.stopPropagation();
	
	const id = jQuery(event.currentTarget).data('id');
	const is_temp = jQuery(event.currentTarget).data('is-temp');
	
	if(is_temp)
	{
		jQuery('#wcafw_company_container_'+id).remove();
	}
	else 
	{
		jQuery('#wcafw_company_container_'+id).hide();
		jQuery('#wcafw_delete_field_'+id).val("yes");
	}
	
	return false;
}